From 9a26097514431e46f6716d944e22fbd3d687627f Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Sat, 21 Aug 2010 23:09:14 +0900
Subject: [PATCH 19/51] do not refer to cref->nd_next->nd_omod if cref->nd_next is 1.
 fixed tests for nested methods.

---
 bootstraptest/test_method.rb |    7 ++++---
 vm_insnhelper.c              |    4 +++-
 2 files changed, 7 insertions(+), 4 deletions(-)

diff --git a/bootstraptest/test_method.rb b/bootstraptest/test_method.rb
index 8d0db6e..c6c3b09 100644
--- a/bootstraptest/test_method.rb
+++ b/bootstraptest/test_method.rb
@@ -287,16 +287,17 @@ assert_equal '1',       %q( class C; def m() 1 end end
 assert_equal '1',       %q( class C
                               def m
                                 def mm() 1 end
+                                mm
                               end
                             end
-                            C.new.m
-                            C.new.mm )
+                            C.new.m )
 assert_equal '1',       %q( class C
                               def m
                                 def mm() 1 end
+                                mm
                               end
                             end
-                            instance_eval "C.new.m; C.new.mm" )
+                            instance_eval "C.new.m" )
 
 # method_missing
 assert_equal ':m',      %q( class C
diff --git a/vm_insnhelper.c b/vm_insnhelper.c
index 3c377ae..49dc785 100644
--- a/vm_insnhelper.c
+++ b/vm_insnhelper.c
@@ -1110,7 +1110,9 @@ vm_cref_push(rb_thread_t *th, VALUE klass, int noex, rb_block_t *blockptr)
     else if (cfp) {
 	cref->nd_next = vm_get_cref0(cfp->iseq, cfp->lfp, cfp->dfp);
     }
-    if (cref->nd_next && !NIL_P(cref->nd_next->nd_omod)) {
+    /* TODO: why cref->nd_next is 1? */
+    if (cref->nd_next && cref->nd_next != 1 &&
+	!NIL_P(cref->nd_next->nd_omod)) {
 	cref->nd_omod = rb_hash_dup(cref->nd_next->nd_omod);
     }
 
-- 
1.7.0.4

